<?

 /*****************************************************************************
 * Filename: images/index.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 ini_set("display_errors", 0); //don't show PHP errors in API

 $_path["root"]="../";
 require($_path["root"]."include.php");

 if($_session->inBackend()) //backend project
  $_session->frontend(); //switch to frontend project

 require_once($_path["include"]."functions.php");
 require_once($_path["include"]."data.php");
 require_once($_path["include"]."errors.php");
 require_once($_path["include"]."image.php");
 require_once($_path["include"]."cache.php");
 require_once($_path["include"]."dt.php");

 $e=new Errors();

 //parse request vars
 if($p=request("p")) //mod rewrite
 {
  $start=false;
  $pSize=sizeof($p);

  for($c=0;$c<$pSize;$c++)
  {
   if(preg_match("/^\d+$/", $p[$c])) //first number found (nr field)
   {
    if($c>=2)//../module/field/nr/
    {
     $module=$p[$c-2];
     $field=$p[$c-1];
     $nr=$p[$c];
    }
    else if($c==1)//module/nr/
    {
     $module=$p[$c-1];
     $nr=$p[$c];
    }
    else //nr/
     $nr=$p[$c];

    if(isset($nr))
    {
     $start=$c+1;
     break;
    }
   }
  }

  if($start&&$start<$pSize)
  {
   for($c=$start;$c<$pSize;$c++) //..nr/width/100/height/200/nocache/rotate/left/ (order may vary)
   {
    switch($p[$c])
    {
     case "width":
     {
      if(isset($p[$c+1])&&preg_match("/^\d+$/", $p[$c+1])) //../nr/width/100/
      {
       $width=$p[$c+1];
       $c++;
      }

      break;
     }
     case "height":
     {
      if(isset($p[$c+1])&&preg_match("/^\d+$/", $p[$c+1])) //../nr/height/100/
      {
       $height=$p[$c+1];
       $c++;
      }

      break;
     }
     case "rotate":
     {
      if(isset($p[$c+1])) //../nr/rotate/left/
      {
       $rotate=$p[$c+1];
       $c++;
      }

      break;
     }
     case "nocache":
     {
      $nocache=true;
      break;
     }
     case "redirect":
     {
      $redirect=true;
      break;
     }
     default: //unknown argument
      break;
    }
   }
  }

  unset($pSize, $c, $start);
 }
 else
 {
  $module=request("m");
  $field=request("field");
  $nr=request("nr");

  $width=request("width");
  $height=request("height");
  $rotate=request("rotate");

  $nocache=isset($_GET["nocache"]);
  $redirect=isset($_GET["redirect"]);
 }
 unset($p);


 //validate request vars
 if(isset($module)&&$module)
  $module=strip_tags($module);
 else
  $module="images";

 if(isset($field)&&$field)
  $field=strip_tags($field);
 else
  $field=false;

 if(isset($nr)&&$nr)
  $nr=strip_tags($nr);
 else
  $nr=0;

 if(isset($width)&&$width)
  $width=abs($width);
 else
  $width=false;

 if(isset($height)&&$height)
  $height=abs($height);
 else
  $height=false;

 if(isset($rotate)&&$rotate)
 {
  if(!preg_match("/^[0-9a-z]+$/i", $rotate)) //must be alphanumeric
  {
   $e->add("Illegal rotation", "hack");
   $rotate=false;
  }
 }
 else
  $rotate=false;

 if(isset($nocache)&&$nocache)
  $nocache=true;
 else
  $nocache=false;

 if(isset($redirect)&&$redirect)
  $redirect=true;
 else
  $redirect=false;


 //select module
 $d=new Data($module, "view", "item");

 //identifier
 $d->setValue("nr", $nr);

 //module field to display
 if($field)
 {
  if(!$d->check("type", "image", $field)&&!$d->check("type", "file", $field)&&!$d->check("type", "localfile", $field))
   $e->add("Incorrect image field for module: \"".$module."\"", "hack");
 }
 else //autodetect
 {
  //get first image field
  foreach($d->check("type", "image") as $field)
   break;

  if(!$field)
  {
   //get first file field
   foreach($d->check("type", "file") as $field)
    break;

   if(!$field)
   {
    //get first local file field
    foreach($d->check("type", "localfile") as $field)
     break;

    if(!$field)
     $e->add("No image field for module: \"".$module."\"", "hack");
   }
  }
 }

 if($nocache||$redirect||(!$width&&!$height&&!$rotate)) //no caching or reason to cache
  $cache=false;
 else //caching
 {
  //get field and last updated (not the data)
  $d->setShowFields($field, "updated");

  if(!$d->get()||!$d->next()) //no image returned... prolly will error later on as well
   $cache=false;
  else //see if cached version exists
  {
   //cache file name
   $cachefile=$d->module."-nr-".$d->getValue("nr")."-".$field."-".$width."x".$height;

   if($rotate) //add (optional) rotation to cache file name
    $cachefile.="_".$rotate;

   if(preg_match("/(\.[a-z]+)$/i", $d->v[$field], $tmp)) //added extension
    $cachefile.=strtolower($tmp[1]);

   $cachetime=DT::dateConvertS($d->v["updated"], $d->format[$d->dataformat]["datetimeformat"]);

   $cache=new Cache("file");
   if($cache->time($cachefile)==$cachetime) //cached, output and exit
   {
    print $cache->output($cachefile);
    exit;
   }
   else if($cache->exists($cachefile)) //cached version exist
    $cache->remove($cachefile); //remove so it can be updated
  }

  //no cache available

  $d->clearValues();
  $d->setValue("nr", $nr);
 }

 //failure?
 if($e->any("fatal"))
  imgerror($width, $height);

 //load image from data object
 $image=new Image();

 if($redirect)
 {
  if(!$image->redirectData($d, $field)) //error
  {
   $e->add($image->e);
   imgerror($width, $height);
  }

  exit; //done
 }
 else
 {
  if(!$image->loadData($d, $field)) //error
  {
   $e->add($image->e);
   imgerror($width, $height);
  }
 }

 //resize
 if($width||$height)
 {
  if(!$image->resize($width, $height))
   $width=$height=0;
 }

 //rotate (after resize to speed it up)
 if($rotate)
 {
  if(!$image->rotate($rotate))
   $rotate=false;
  else if($width||$height) //resize again to correct size
  {
   if(!$image->resize($width, $height))
    $width=$height=0;
  }
 }

 //output
 if($content=$image->output()) //get output
 {
  if($cache&&($width||$height||$rotate)) //cache if necessary
   $cache->save($cachefile, $content, $cachetime);

  print $content; //output content and exit
  exit;
 }

 //error generating image
 $e->add($image->e);
 imgerror($width, $height);


 /*
  * error function, displays imagenotfound.png
  */
 function imgerror($width, $height)
 {
  global $_path;

  $image=new Image();
  $image->load($_path["images"]."imagenotfound.png");

  if($width||$height)
   $image->resize($width, $height);

  print $image->output();
  exit;
 }
?>
