<?

 /*****************************************************************************
 * Filename: include/modules/history.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class System_Module_history extends Module
 {
  function __construct(&$data)
  {
   global $_session, $_config;

   parent::__construct($data);

   if(!$_config->get("modules.".$this->data->module.".field.time"))
   {
    $time=Array(
     "timezone" => "UTC",
     "formtimezone" => "UTC",
     "dateformat" => "d-m-Y",
     "timeformat" => "H:i:s",
     "datetimeformat" => "H:i:s d-m-Y",
     "formdateformat" => "d-m-Y",
     "formtimeformat" => "H:i:s",
     "formdatetimeformat" => "H:i:s d-m-Y",
    );

    $_config->set("modules.".$this->data->module.".field.time", $time);
   }

   $this->data->format["sql"]["timezone"]="UTC";

   $this->data->title="Page history";

   $this->data->defaultFields("id");

   $this->data->addField("uri", "text", "all", false, 0, 65536, false, "Request URI");
   $this->data->addField("time", "datetime", "all", false, false, false, false, "Request time");

   $this->data->addField("method", "enum", "all", "title", 1, 5, false, "Request method");
   $this->data->enumOptions("method", "", "GET", "POST");

   $this->data->addField("project", "project", "all", false, 1, 25, $_session->get("project"), "Project");
   $this->data->addField("cms", "boolean", "all", false, false, false, false, "CMS page");

   $this->data->sortOrder("time-");
  }

  function postInit()
  {
   //set default values
   if(isset($_SERVER["REQUEST_TIME"]))
   {
    $difference=$_SERVER["REQUEST_TIME"]-time();

    if($difference>0) //later
     $this->data->field["time"]["defaultvalue"]="now+".$difference;
    else if($difference<0) //before
     $this->data->field["time"]["defaultvalue"]="now".$difference;
    else
     $this->data->field["time"]["defaultvalue"]="now";
   }
   else
    $this->data->field["time"]["defaultvalue"]="now";

   $this->data->field["uri"]["defaultvalue"]=(isset($_SERVER["REQUEST_URI"])?$_SERVER["REQUEST_URI"]:"");
   $this->data->field["method"]["defaultvalue"]=(isset($_SERVER["REQUEST_METHOD"])?$_SERVER["REQUEST_METHOD"]:"");

   if($this->data->check("valuetype", "none", "uri"))
    $this->data->setDefaultValue("uri");

   if($this->data->check("valuetype", "none", "time"))
    $this->data->setDefaultValue("time");

   if($this->data->check("valuetype", "none", "method"))
    $this->data->setDefaultValue("method");

   return true;
  }
 }
?>
