<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/captcha.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."captcha.php");

 class UT_Captcha extends UT_Classes
 {
  function Constructor()
  {
   $object=new Captcha();

   if(!is_object($object)||get_class($object)!="Captcha")
   {
    $this->e->add("Constructor doesn't return a Captcha object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   //config merge
   $object=new Captcha(Array("length" => 7, "backgroundTransparent" => false, "backgroundColor" => "255,0,0"));

   if($object->length!=7)
   {
    $this->e->add("Captcha length should be \"7\"");
    return UT_FAILED;
   }

   if($object->config["backgroundTransparent"])
   {
    $this->e->add("Captcha background shouldn't be transparent");
    return UT_FAILED;
   }

   if($object->colors["background"]!=Array(255,0,0))
   {
    $this->e->add("Captcha background color should be \"255,0,0\"");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new Captcha();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("Captcha object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->mime=true;
   if($orig->mime==$copy->mime)
   {
    $this->e->add("Captcha object copy also modified original \"mime\" variable", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("Captcha object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Output()
  {
   $cap=new Captcha();

   $this->_storeHeaders();
   if(!($output=$cap->output(true))) //with headers
   {
    $this->e->add("Captcha output failed", "error");
    $this->e->add($cap->e);
    return UT_FAILED;
   }

   if(!preg_grep("!Content-Disposition: inline; filename=\"captcha\.\w+\"!i", headers_list()))
   {
    $this->e->add("Captcha output Content-Disposition header not found or incorrect", "error");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   if(!preg_grep("!Content-Type: image/\w+!i", headers_list()))
   {
    $this->e->add("Captcha output Content-Type header not found or incorrect", "error");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   if(!preg_grep("!Content-Length: \d+!i", headers_list()))
   {
    $this->e->add("Captcha output Content-Length header not found or incorrect", "error");
    $this->_restoreHeaders();
    return UT_FAILED;
   }

   $this->_restoreHeaders();

   return UT_OK;
  }
 }

?>
