<?

 /*****************************************************************************
 * Filename: project/jas/include/backend/search.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["include"]."backend/base.php");
 require_once($_path["include"]."mutilate.php");

 class Backend_Search extends Backend_Base
 {
  function __construct(&$backend)
  {
   parent::__construct($backend);
  }


  /*
   * Output
   */

  function output()
  {
   $r="";

   if($this->backend->search) //inline search
   {
    if($this->backend->search["inline"])
    {
     $option=Array();
     foreach($this->backend->search as $k => $v)
      $options[]=$k."=".$v;

     $r.=$this->form->input("hidden", "_searchOptions", implode(";", $options))."\n";
    }

    if($placeholder=request("search"))
     $placeholder=Mutilate::htmlEncodeS($placeholder);
    else
     $placeholder=$this->language->t("Search");

    $r.=$this->form->input("text", "search", false, false, false, "placeholder=\"".$placeholder."\" autocomplete=\"off\"");
    $r.=$this->form->button("", $this->icon("view".(!$this->backend->search["inline"]?"_dim":""), "small"), false, false, "submit");

    $r=$this->form($r, $this->backend->search["url"]);
   }
   else //disabled
   {
    $placeholder=$this->language->t("Search");

    $r.=$this->form->input("text", "search", false, false, false, "placeholder=\"".$placeholder."\" autocomplete=\"off\" disabled");
    $r.=$this->form->button("", $this->icon("view_disabled", "small"), false, false, "disabled submit");
   }

   return $r;
  }
 }
?>
