

 /*****************************************************************************
 * Filename: project/jas/script/groups.js
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


if(typeof(onload)!='function')
 alert("Script not loaded: functions.js");
else if(typeof(getCookie)!="function")
 alert("Script not loaded: cookies.js");
else if(typeof(setGetElementFunctions)!="function")
 alert("Script not loaded: getelements.js");
else if(typeof(Flash)!="function")
 alert("Script not loaded: flash.js");
else
 onload("animateGroups();");

function animateGroups()
{
 groups=document.getElementsByClassName("groups"); //get all group groups

 if(groups.length==0) //no groups
  return false;

 for(c=0;c<groups.length;c++)
 {
  groupTabs=document.createElement("ul");
  groupTabs.className="groupTabs";

  groups[c].insertBefore(groupTabs, groups[c].childNodes[0]); //insert tab bar

  height=0;

  for(x=0;x<groups[c].childNodes.length;x++)
  {
   if(groups[c].childNodes[x].className!=undefined&&groups[c].childNodes[x].className.match(/^group(\s|$)/)) //one of the x groups
   {
    group=groups[c].childNodes[x];

    groupTabs.innerHTML+="<li class=\"groupTab\"><a id=\"groupID_"+c+"_"+x+"\">"+group.childNodes[0].innerHTML+"</a></li>";

    fields=group;
    fields.style.display="block";
    fields.style.overflow="hidden";

    group.flash=new Flash(fields);
    group.flash.width-=12; //hack for jas style sheet (border+padding)

    if(group.flash.height>height)
     height=group.flash.height;

    group.groupID=c+"_"+x;
    group.status="closing";
   }
  }

  for(x=0;x<groups[c].childNodes.length;x++)
  {
   if(groups[c].childNodes[x].className!=undefined&&groups[c].childNodes[x].className.match(/^group /)) //one of the x groups
   {
    group=groups[c].childNodes[x].height=height;

    document.getElementById("groupID_"+c+"_"+x).onclick=groupsMove;
    document.getElementById("groupID_"+c+"_"+x).style.cursor="pointer";
   }
  }

  //XXX: fix
  if(!(openGroup=getCookie("lastOpenGroup_"+groups[c].className.split(" ")[1])))
   openGroup=false;

  for(x=0;x<groups[c].childNodes.length;x++)
  {
   if(groups[c].childNodes[x].className!=undefined&&groups[c].childNodes[x].className.match(/^group /)) //one of the x groups
   {
    if(openGroup==false)
     openGroup=x;

    group=groups[c].childNodes[x];

    if(openGroup!=x)
    {
     group.flash.resize(group.flash.width, 0, 0);
     group.flash.end("groupsStatus(\""+group.groupID+"\", \"closed\");");
     group.flash.go();
    }
   }
  }
 }

 return true;
}

function groupsMove(event)
{
 if(!event)//clientX , clientY , fromElement , toElement , height , width , keycode , layerX , layerY , modifiers , offsetX , offsetY , pageX , pageY , reason , returnValue , screenX , screenY , srcElement , srcFilter , target , type , which , x, y
  event=window.event;

 if(!(id=this.id.match(/groupID_(.+)/)))
  return ;

 id=id[1];
 group=false;
 all=document.getAllElements();

 for(c=0;c<all.length;c++)
 {
  if(all[c].groupID!=undefined&&all[c].groupID==id)
  {
   group=all[c];
   break;
  }
 }

 if(!group)
  return;


 if(event.type=="mouseover"||event.type=="mousedown"||event.type=="click")
 {
  if(group.status=="open"||group.status=="opening")
   return;
  else if(group.status=="closing")
  {
   group.status="open";
   return;
  }

  mainGroup=id.split("_")[0];

  for(c=0;c<all.length;c++)
  {
   if(all[c].groupID!=undefined)
   {
    if(all[c].groupID.split("_")[0]==mainGroup&&all[c].groupID!=id) //close other groups in main group
    {
     if(!all[c].status!="closed")
     {
      all[c].status="closing";
      groupsClose(all[c].groupID);
     }
    }
   }
  }

  group.status="opening";

  setCookie("lastOpenGroup_"+group.parentNode.className.split(" ")[1], group.groupID.split("_")[1], 300/86400); //save last open group from this groups collection for 5 minutes

  e=group.flash.resize(group.flash.width,group.flash.height, 100);
  group.flash.decelerate(e);
  group.flash.end("groupsStatus(\""+group.groupID+"\", \"open\");");
  group.flash.go();
  group.style.display="block";
 }
 else
 {
  if(group.status=="open"||group.status=="opening")
  {
//   group.status="closing";
//   setTimeout("groupsClose("+group.groupID+");", 500);
  }
 }
}
function groupsClose(groupID)
{
 list=false;
 all=document.getAllElements();

 for(c=0;c<all.length;c++)
 {
  if(all[c].groupID!=undefined&&all[c].groupID==groupID)
  {
   list=all[c];
   break;
  }
 }

 if(list.status=="closing")
 {
  e=list.flash.resize(list.flash.width,0, 100);
  list.flash.accelerate(e);
  list.flash.end("groupsStatus(\""+list.groupID+"\", \"closed\");");
  list.flash.go();
 }
}
function groupsStatus(groupID, status)
{
 list=false;
 all=document.getAllElements();

 for(c=0;c<all.length;c++)
 {
  if(all[c].groupID!=undefined&&all[c].groupID==groupID)
  {
   list=all[c];
   break;
  }
 }

 if(!list)
  return false;

 list.status=status;

 if(status=="closed")
  list.style.display="none";
}
